/*
***********************************************************************************************
*						SHT1x digital temperature and humidity sensor Driver
*										All Rights Reserved
* File name		: SHT1x.c
* Programmer 	: John Leung, TechToys Co. Hong Kong
* Web presence  : www.TechToys.com.hk
* Note			: 
* Language		: C30 complier version 2.40, MPLAB v8.14
* Hardware		: PIC24LF128
* Date			: 11 Oct 2006			Version 1.0 

***********************************************************************************************
*										DESCRIPTION
*
* This module provides an interface to Sensirion SHT10 digital temperature & humidity sensor
*
* pinout function summarized as below
* ---SHT1x			MCU -----------------
* DATA - data		RB2
* SCK  - clock		RB0
***********************************************************************************************
*/

#ifndef _C_SHT1X_H_
#define _C_SHT1X_H_

#define _SHT_MEASUREMENT_DELAY	500
#define SHT11_CALCULATE_DEW
#if _SHT_MEASUREMENT_DELAY < 500
	#error According to datasheet measurement should use 10%. Like 2 measurement every sec
#endif

#endif
