#ifndef _C_NRF24L01_H_
#define _C_NRF24L01_H_

#include "mal.h"
#include "i_sio.h"
#include "c_sio.h"

#define NRF24L01P

#define NRF_PORT_SYNC() 	_sync()


#define RADIO_RX_LEN 32
#define RADIO_TX_LEN 64

#define CHANNEL_CFG 130
#define ADDRESS_LENGTH 5

#define NRFDELAY_CNT	700	//Configure this to 65us delay. see function implementation
#define NRF_TX_TIMEOUT	10	//How much time we should wait to transmit a packet

#define NRF_ADDRESSLSB	0x90

#define NRF_POLLING
#define NRF_POLLING_IN_MAIN_CONTEXT

#define NRF24L01_USE_BUFFERED_RXTX_MODE

//#define NRF24L01_NOTIFY_RX_PACKET() ;
#define NRF24L01_NOTIFY_RX_PACKET() isr_communication()

//Unknown ???
//#define IRQ_TRIS	TRISEbits.TRISE0
//#define IRQ_PORT	PORTEbits.RE0
//
//#define CE_TRIS		TRISEbits.TRISE1
//#define CE_LAT		LATEbits.LATE1
//#define CE_PORT		PORTEbits.RE1
//
//#define CSN_TRIS	TRISEbits.TRISE2
//#define CSN_LAT		LATEbits.LATE2
//#define CSN_PORT	PORTEbits.RE2

//UEXT but maybe not olimex pinout (VRC-6A board) Currently used as gateway
#define IRQ_TRIS	TRISDbits.TRISD10
#define IRQ_PORT	PORTDbits.RD10

#define CE_TRIS		TRISFbits.TRISF5
#define CE_LAT		LATFbits.LATF5
#define CE_PORT		PORTFbits.RF5

#define CSN_TRIS	TRISFbits.TRISF4
#define CSN_LAT		LATFbits.LATF4
#define CSN_PORT	PORTFbits.RF4

//Olimex Pinguino with LiPo
//#define IRQ_TRIS	TRISEbits.TRISE5
//#define IRQ_PORT	PORTEbits.RE5
//
//#define CE_TRIS		TRISEbits.TRISE4
//#define CE_LAT		LATEbits.LATE4
//#define CE_PORT		PORTEbits.RE4
//
//#define CSN_TRIS	TRISEbits.TRISE3
//#define CSN_LAT		LATEbits.LATE3
//#define CSN_PORT	PORTEbits.RE3

#endif
